## ocaml 5.4.0

=== Makefile ===
#**************************************************************************
#*                                                                        *
#*                                 OCaml                                  *
#*                                                                        *
#*            Xavier Leroy, projet Cristal, INRIA Rocquencourt            *
#*                                                                        *
#*   Copyright 1999 Institut National de Recherche en Informatique et     *
#*     en Automatique.                                                    *
#*                                                                        *
#*   All rights reserved.  This file is distributed under the terms of    *
#*   the GNU Lesser General Public License version 2.1, with the          *
#*   special exception on linking described in the file LICENSE.          *
#*                                                                        *
#**************************************************************************

# The main Makefile

ROOTDIR = .
# NOTE: it is important that the OCAMLDEP and OCAMLLEX variables
# are defined *before* Makefile.common gets included, so that
# their local definitions here take precedence over their
# general shared definitions in Makefile.common.
OCAMLLEX ?= $(BOOT_OCAMLLEX)
include Makefile.common
include Makefile.best_binaries

.PHONY: defaultentry
defaultentry: $(DEFAULT_BUILD_TARGET)

include stdlib/StdlibModules

CAMLC = $(BOOT_OCAMLC) $(BOOT_STDLIBFLAGS) -use-prims runtime/primitives
CAMLOPT=$(OCAMLRUN) ./ocamlopt$(EXE) $(STDLIBFLAGS) -I otherlibs/dynlink
ARCHES=amd64 arm64 power s390x riscv
VPATH = utils parsing typing bytecomp file_formats lambda middle_end \
  middle_end/closure middle_end/flambda middle_end/flambda/base_types \
  asmcomp driver toplevel tools runtime \
  $(addprefix otherlibs/, $(ALL_OTHERLIBS))
INCLUDES = $(addprefix -I ,$(VPATH))

ifeq "$(strip $(NATDYNLINKOPTS))" ""
OCAML_NATDYNLINKOPTS=
else
OCAML_NATDYNLINKOPTS = -ccopt "$(NATDYNLINKOPTS)"
endif

OC_OCAMLDEPDIRS = $(VPATH)

# This list is passed to expunge, which accepts both uncapitalized and
# capitalized module names.
PERVASIVES=$(STDLIB_MODULES) outcometree topprinters topdirs toploop

LIBFILES=stdlib.cma std_exit.cmo *.cmi $(HEADER_NAME)

COMPLIBDIR=$(LIBDIR)/compiler-libs

TOPINCLUDES=$(addprefix -I otherlibs/,$(filter-out %threads,$(OTHERLIBRARIES)))

expunge := expunge$(EXE)

# Targets and dependencies for the compilerlibs/*.{cma,cmxa} archives

utils_SOURCES = $(addprefix utils/, \
  config.mli config.ml \
  build_path_prefix_map.mli build_path_prefix_map.ml \
  format_doc.mli format_doc.ml \
  misc.mli misc.ml \
  identifiable.mli identifiable.ml \
  numbers.mli numbers.ml \
  arg_helper.mli arg_helper.ml \
  local_store.mli local_store.ml \
  load_path.mli load_path.ml \
  clflags.mli clflags.ml \
  profile.mli profile.ml \
  terminfo.mli terminfo.ml \
  ccomp.mli ccomp.ml \
  warnings.mli warnings.ml \
  consistbl.mli consistbl.ml \
  linkdeps.mli linkdeps.ml \
  strongly_connected_components.mli strongly_connected_components.ml \
  targetint.mli targetint.ml \
  int_replace_polymorphic_compare.mli int_replace_polymorphic_compare.ml \
  domainstate.mli domainstate.ml \
  binutils.mli binutils.ml \
  lazy_backtrack.mli lazy_backtrack.ml \
  diffing.mli diffing.ml \
  diffing_with_keys.mli diffing_with_keys.ml \
  compression.mli compression.ml)

parsing_SOURCES = $(addprefix parsing/, \
  location.mli location.ml \
  unit_info.mli unit_info.ml \
  asttypes.mli asttypes.ml \
  longident.mli longident.ml \
  parsetree.mli \
  docstrings.mli docstrings.ml \
  syntaxerr.mli syntaxerr.ml \
  ast_helper.mli ast_helper.ml \
  ast_iterator.mli ast_iterator.ml \
  builtin_attributes.mli builtin_attributes.ml \
  camlinternalMenhirLib.mli camlinternalMenhirLib.ml \
  parser.mly \
  lexer.mll \
  pprintast.mli pprintast.ml \
  parse.mli parse.ml \
  printast.mli printast.ml \
  ast_mapper.mli ast_mapper.ml \
  attr_helper.mli attr_helper.ml \
  ast_invariants.mli ast_invariants.ml \
  depend.mli depend.ml)

typing_SOURCES = \
  typing/annot.mli \
  typing/value_rec_types.mli \
  typing/ident.mli typing/ident.ml \
  typing/path.mli typing/path.ml \
  typing/primitive.mli typing/primitive.ml \
  typing/type_immediacy.mli typing/type_immediacy.ml \
  typing/outcometree.mli \
  typing/shape.mli typing/shape.ml \
  typing/types.mli typing/types.ml \
  typing/data_types.mli typing/data_types.ml \
  typing/rawprinttyp.mli typing/rawprinttyp.ml \
  typing/gprinttyp.mli typing/gprinttyp.ml \
  typing/btype.mli typing/btype.ml \
  typing/oprint.mli typing/oprint.ml \
  typing/subst.mli typing/subst.ml \
  typing/predef.mli typing/predef.ml \
  typing/datarepr.mli typing/datarepr.ml \
  file_formats/cmi_format.mli file_formats/cmi_format.ml \
  typing/persistent_env.mli typing/persistent_env.ml \
  typing/env.mli typing/env.ml \
  typing/errortrace.mli typing/errortrace.ml \
  typing/typedtree.mli typing/typedtree.ml \
  typing/signature_group.mli typing/signature_group.ml \
  typing/printtyped.mli typing/printtyped.ml \
  typing/ctype.mli typing/ctype.ml \
  typing/out_type.mli typing/out_type.ml \
  typing/printtyp.mli typing/printtyp.ml \
  typing/errortrace_report.mli typing/errortrace_report.ml \
  typing/includeclass.mli typing/includeclass.ml \
  typing/mtype.mli typing/mtype.ml \
  typing/envaux.mli typing/envaux.ml \
  typing/includecore.mli typing/includecore.ml \
  typing/tast_iterator.mli typing/tast_iterator.ml \
  typing/tast_mapper.mli typing/tast_mapper.ml \
  typing/stypes.mli typing/stypes.ml \
  typing/shape_reduce.mli typing/shape_reduce.ml \
  file_formats/cmt_format.mli file_formats/cmt_format.ml \
  typing/cmt2annot.mli typing/cmt2annot.ml \
  typing/untypeast.mli typing/untypeast.ml \
  typing/includemod.mli typing/includemod.ml \
  typing/includemod_errorprinter.mli typing/includemod_errorprinter.ml \
  typing/typetexp.mli typing/typetexp.ml \
  typing/printpat.mli typing/printpat.ml \
  typing/patterns.mli typing/patterns.ml \
  typing/parmatch.mli typing/parmatch.ml \
  typing/typedecl_properties.mli typing/typedecl_properties.ml \
  typing/typedecl_variance.mli typing/typedecl_variance.ml \
  typing/typedecl_unboxed.mli typing/typedecl_unboxed.ml \
  typing/typedecl_immediacy.mli typing/typedecl_immediacy.ml \
  typing/typedecl_separability.mli typing/typedecl_separability.ml \
  typing/typeopt.mli typing/typeopt.ml \
  typing/typedecl.mli typing/typedecl.ml \
  typing/value_rec_check.mli typing/value_rec_check.ml \
  typing/typecore.mli typing/typecore.ml \
  typing/typeclass.mli typing/typeclass.ml \
  typing/typemod.mli typing/typemod.ml

lambda_SOURCES = $(addprefix lambda/, \
  debuginfo.mli debuginfo.ml \
  lambda.mli lambda.ml \
  printlambda.mli printlambda.ml \
  switch.mli switch.ml \
  matching.mli matching.ml \
  value_rec_compiler.mli value_rec_compiler.ml \
  translobj.mli translobj.ml \
  translattribute.mli translattribute.ml \
  translprim.mli translprim.ml \
  translcore.mli translcore.ml \
  translclass.mli translclass.ml \
  translmod.mli translmod.ml \
  tmc.mli tmc.ml \
  simplif.mli simplif.ml \
  runtimedef.mli runtimedef.ml)

comp_SOURCES = \
  file_formats/cmo_format.mli \
  file_formats/cmx_format.mli \
  file_formats/cmxs_format.mli \
  bytecomp/meta.mli bytecomp/meta.ml \
  bytecomp/opcodes.mli bytecomp/opcodes.ml \
  bytecomp/bytesections.mli bytecomp/bytesections.ml \
  bytecomp/dll.mli bytecomp/dll.ml \
  bytecomp/symtable.mli bytecomp/symtable.ml \
  driver/pparse.mli driver/pparse.ml \
  driver/compenv.mli driver/compenv.ml \
  driver/main_args.mli driver/main_args.ml \
  driver/compmisc.mli driver/compmisc.ml \
  driver/makedepend.mli driver/makedepend.ml \
  driver/compile_common.mli driver/compile_common.ml
# All file format descriptions (including cmx{,s}) are in the
# ocamlcommon library so that ocamlobjinfo can depend on them.

ocamlcommon_SOURCES = \
  $(utils_SOURCES) $(parsing_SOURCES) $(typing_SOURCES) \
  $(lambda_SOURCES) $(comp_SOURCES)

ocamlbytecomp_SOURCES = \
  bytecomp/instruct.mli bytecomp/instruct.ml \
  bytecomp/bytegen.mli bytecomp/bytegen.ml \
  bytecomp/printinstr.mli bytecomp/printinstr.ml \
  bytecomp/emitcode.mli bytecomp/emitcode.ml \
  bytecomp/bytelink.mli bytecomp/bytelink.ml \
  bytecomp/bytelibrarian.mli bytecomp/bytelibrarian.ml \
  bytecomp/bytepackager.mli bytecomp/bytepackager.ml \
  driver/errors.mli driver/errors.ml \
  driver/compile.mli driver/compile.ml \
  driver/maindriver.mli driver/maindriver.ml

intel_SOURCES = \
  x86_ast.mli \
  x86_proc.mli x86_proc.ml \
  x86_dsl.mli x86_dsl.ml \
  x86_gas.mli x86_gas.ml \
  x86_masm.mli x86_masm.ml

asmcomp_SOURCES = \
  $(addprefix asmcomp/, $(arch_specific_SOURCES)) \
  asmcomp/arch.mli asmcomp/arch.ml \
  asmcomp/cmm.mli asmcomp/cmm.ml \
  asmcomp/printcmm.mli asmcomp/printcmm.ml \
  asmcomp/reg.mli asmcomp/reg.ml \
  asmcomp/mach.mli asmcomp/mach.ml \
  asmcomp/proc.mli asmcomp/proc.ml \
  asmcomp/strmatch.mli asmcomp/strmatch.ml \
  asmcomp/cmmgen_state.mli asmcomp/cmmgen_state.ml \
  asmcomp/cmm_helpers.mli asmcomp/cmm_helpers.ml \
  asmcomp/afl_instrument.mli asmcomp/afl_instrument.ml \
  asmcomp/thread_sanitizer.mli asmcomp/thread_sanitizer.ml \
  asmcomp/cmmgen.mli asmcomp/cmmgen.ml \
  asmcomp/cmm_invariants.mli asmcomp/cmm_invariants.ml \
  asmcomp/interval.mli asmcomp/interval.ml \
  asmcomp/printmach.mli asmcomp/printmach.ml \
  asmcomp/dataflow.mli asmcomp/dataflow.ml \
  asmcomp/polling.mli asmcomp/polling.ml \
  asmcomp/selectgen.mli asmcomp/selectgen.ml \
  asmcomp/selection.mli asmcomp/selection.ml \
  asmcomp/comballoc.mli asmcomp/comballoc.ml \
  asmcomp/CSEgen.mli asmcomp/CSEgen.ml \
  asmcomp/CSE.mli asmcomp/CSE.ml \
  asmcomp/liveness.mli asmcomp/liveness.ml \
  asmcomp/spill.mli asmcomp/spill.ml \
  asmcomp/split.mli asmcomp/split.ml \
  asmcomp/interf.mli asmcomp/interf.ml \
  asmcomp/coloring.mli asmcomp/coloring.ml \
  asmcomp/linscan.mli asmcomp/linscan.ml \
  asmcomp/reloadgen.mli asmcomp/reloadgen.ml \
  asmcomp/reload.mli asmcomp/reload.ml \
  asmcomp/deadcode.mli asmcomp/deadcode.ml \
  asmcomp/stackframegen.mli asmcomp/stackframegen.ml \
  asmcomp/stackframe.mli asmcomp/stackframe.ml \
  asmcomp/linear.mli asmcomp/linear.ml \
  asmcomp/printlinear.mli asmcomp/printlinear.ml \
  asmcomp/linearize.mli asmcomp/linearize.ml \
  file_formats/linear_format.mli file_formats/linear_format.ml \
  asmcomp/schedgen.mli asmcomp/schedgen.ml \
  asmcomp/scheduling.mli asmcomp/scheduling.ml \
  asmcomp/branch_relaxation.mli asmcomp/branch_relaxation.ml \
  asmcomp/emitaux.mli asmcomp/emitaux.ml \
  asmcomp/emit.mli asmcomp/emit.ml \
  asmcomp/asmgen.mli asmcomp/asmgen.ml \
  asmcomp/asmlink.mli asmcomp/asmlink.ml \
  asmcomp/asmlibrarian.mli asmcomp/asmlibrarian.ml \
  asmcomp/asmpackager.mli asmcomp/asmpackager.ml \
  driver/opterrors.mli driver/opterrors.ml \
  driver/optcompile.mli driver/optcompile.ml \
  driver/optmaindriver.mli driver/optmaindriver.ml

# Files under middle_end/ are not to reference files under asmcomp/.
# This ensures that the middle end can be linked (e.g. for objinfo) even when
# the native code compiler is not present for some particular target.

middle_end_closure_SOURCES = $(addprefix middle_end/closure/, \
  closure.mli closure.ml \
  closure_middle_end.mli closure_middle_end.ml)

# Owing to dependencies through [Compilenv], which would be
# difficult to remove, some of the lower parts of Flambda (anything that is
# saved in a .cmx file) have to be included in the [MIDDLE_END] stanza, below.
middle_end_flambda_SOURCES = \
$(addprefix middle_end/flambda/, \
  import_approx.mli import_approx.ml \
  lift_code.mli lift_code.ml \
  closure_conversion_aux.mli closure_conversion_aux.ml \
  closure_conversion.mli closure_conversion.ml \
  initialize_symbol_to_let_symbol.mli initialize_symbol_to_let_symbol.ml \

=== api_docgen/Makefile ===
#**************************************************************************
#*                                                                        *
#*                                 OCaml                                  *
#*                                                                        *
#*             Florian Angeletti, projet Cambium, Inria Paris             *
#*                                                                        *
#*   Copyright 2020 Institut National de Recherche en Informatique et     *
#*     en Automatique.                                                    *
#*                                                                        *
#*   All rights reserved.  This file is distributed under the terms of    *
#*   the GNU Lesser General Public License version 2.1, with the          *
#*   special exception on linking described in the file LICENSE.          *
#*                                                                        *
#**************************************************************************
# Used by included Makefiles
ROOTDIR = ..
-include ../Makefile.build_config

odoc-%:
	$(MAKE) -C odoc $*

ocamldoc-%:
	$(MAKE) -C ocamldoc $*

ifeq ($(DOCUMENTATION_TOOL),odoc)
man: odoc-man
latex: odoc-latex
html: odoc-html
	@echo "documentation is in ./api_docgen/odoc/build/html/"
all: html latex man
install: odoc-install
else
man: ocamldoc-man
latex: ocamldoc-latex
html: ocamldoc-html
	@echo "documentation is in ./api_docgen/ocamldoc/build/html/"
texi: ocamldoc-texi
pdf: ocamldoc-pdf
all: html pdf man latex texi
install: ocamldoc-install
endif

clean:
	rm -rf build odoc/build ocamldoc/build

distclean: clean

.PHONY: html latex man clean distclean install texi pdf

=== man/Makefile ===
#**************************************************************************
#*                                                                        *
#*                                 OCaml                                  *
#*                                                                        *
#*            Xavier Leroy, projet Cristal, INRIA Rocquencourt            *
#*                                                                        *
#*   Copyright 1999 Institut National de Recherche en Informatique et     *
#*     en Automatique.                                                    *
#*                                                                        *
#*   All rights reserved.  This file is distributed under the terms of    *
#*   the GNU Lesser General Public License version 2.1, with the          *
#*   special exception on linking described in the file LICENSE.          *
#*                                                                        *
#**************************************************************************

ROOTDIR = ..
include $(ROOTDIR)/Makefile.common

MANPAGES = $(addsuffix .1,\
  ocaml ocamlc ocamlc.opt ocamlcp ocamldebug ocamldep ocamldoc ocamllex \
  ocamlmktop ocamlopt ocamlopt.opt ocamloptp ocamlprof ocamlrun ocamlyacc)

.PHONY: install
install:
	$(MKDIR) '$(INSTALL_PROGRAMS_MAN_DIR)'
	$(INSTALL_DATA) $(MANPAGES) '$(INSTALL_PROGRAMS_MAN_DIR)'

=== manual/Makefile ===
all: tools manual tests


# The tools and the tests are rebuilt each time in order to avoid issues with
# different compiler versions
tests: manual
	$(MAKE) -C tests clean
	$(MAKE) -C tests all

tools:
	$(MAKE) -C tools clean
	$(MAKE) -C tools all
	$(MAKE) -C tests tools

manual: tools
	$(MAKE) -C src all

pdf: tools
	$(MAKE) -C src pdf
	@echo "The generated manual is at ./src/texstuff/manual.pdf"

html: tools
	$(MAKE) -C src html
	@echo "The generated manual is at ./src/htmlman/index.html"

web: tools
	$(MAKE) -C src web

release:
	$(MAKE) -C src release

# The pregen-etex target generates the latex files from the .etex
# files to ensure that this phase of the manual build process, which
# may execute OCaml fragments and expect certain outputs, is correct
pregen-etex: tools
	$(MAKE) -C src etex-files

# pregen builds both .etex files and the documentation of the standard library
pregen: tools
	$(MAKE) -C src files


.PHONY: tests manual tools


.PHONY: clean
clean:
	$(MAKE) -C src clean
	$(MAKE) -C tools clean
	$(MAKE) -C tests clean

.PHONY: distclean
distclean: clean
	$(MAKE) -C src distclean
	$(MAKE) -C tools distclean
	$(MAKE) -C tests distclean

=== otherlibs/Makefile ===
#**************************************************************************
#*                                                                        *
#*                                 OCaml                                  *
#*                                                                        *
#*            Gabriel Scherer, projet Parsifal, INRIA Saclay              *
#*                                                                        *
#*   Copyright 2018 Institut National de Recherche en Informatique et     *
#*     en Automatique.                                                    *
#*                                                                        *
#*   All rights reserved.  This file is distributed under the terms of    *
#*   the GNU Lesser General Public License version 2.1, with the          *
#*   special exception on linking described in the file LICENSE.          *
#*                                                                        *
#**************************************************************************

ROOTDIR=..
include $(ROOTDIR)/Makefile.common

# Although the OTHERLIBS variable is defined in ../Makefile.config,
# its following conditional definition needs to be kept because,
# at the moment, the clean targets depend on this variable but
# when they are invoked ../Makefile.config is not included, so that
# OTHERLIBS would be empty and the clean target would thus not work.
OTHERLIBS ?= str systhreads unix runtime_events

# $1: target name to dispatch to all otherlibs/*/Makefile
define dispatch_
$1:
	for lib in $$(OTHERLIBS); do \
	  ($$(MAKE) -C $$$$lib $1) || exit $$$$?; \
	done
endef
define dispatch
$(eval $(call dispatch_,$1))
endef

.PHONY: all allopt clean distclean partialclean
$(call dispatch,all)
$(call dispatch,allopt)
$(call dispatch,clean)
$(call dispatch,distclean)
$(call dispatch,partialclean)

=== stdlib/Makefile ===
#**************************************************************************
#*                                                                        *
#*                                 OCaml                                  *
#*                                                                        *
#*            Xavier Leroy, projet Cristal, INRIA Rocquencourt            *
#*                                                                        *
#*   Copyright 1999 Institut National de Recherche en Informatique et     *
#*     en Automatique.                                                    *
#*                                                                        *
#*   All rights reserved.  This file is distributed under the terms of    *
#*   the GNU Lesser General Public License version 2.1, with the          *
#*   special exception on linking described in the file LICENSE.          *
#*                                                                        *
#**************************************************************************

ROOTDIR = ..
# NOTE: it is important that the OCAMLDEP variable is defined *before*
# Makefile.common gets included, so that its local definition here
# take precedence over its general shared definitions in Makefile.common.
OCAMLDEP ?= $(BOOT_OCAMLDEP)

include $(ROOTDIR)/Makefile.common

# There are three ways the Standard Library is compiled in bytecode:
# 1. During coldstart
#      - using ../boot/ocamlc which runs on ../boot/ocamlrun
# 2. During coreall (via library),
#      - using ../ocamlc which runs on ../boot/ocamlrun
# 3. During coreboot (via library-cross),
#      - using ../ocamlc which at that point runs on ../runtime/ocamlrun
# If $(USE_BOOT_OCAMLC) is non-empty, we select case 1 and use $(BOOT_OCAMLC).
# Otherwise, we use $(OCAMLRUN) ../ocamlc, with $(OCAMLRUN) being
# ../boot/ocamlrun by default, but able to overridden by library-cross to
# ../runtime/ocamlrun.
USE_BOOT_OCAMLC ?=

ifeq "$(USE_BOOT_OCAMLC)" ""
CAMLC = $(OCAMLRUN) $(ROOTDIR)/ocamlc$(EXE)
else
CAMLC = $(BOOT_OCAMLC)
endif
COMPFLAGS = -strict-sequence -absname -w +a-4-9-41-42-44-45-48 \
            -g -warn-error +A -bin-annot -nostdlib -principal
ifeq "$(FLAMBDA)" "true"
OPTCOMPFLAGS += -O3
endif
OPTCOMPILER=$(ROOTDIR)/ocamlopt$(EXE)
CAMLOPT=$(OCAMLRUN) $(OPTCOMPILER)

include StdlibModules

OBJS=$(addsuffix .cmo,$(STDLIB_MODULES))
NOSTDLIB= camlinternalFormatBasics.cmo stdlib.cmo
OTHERS=$(filter-out $(NOSTDLIB),$(OBJS))

.PHONY: all
all: stdlib.cma std_exit.cmo $(HEADER_NAME) target_$(HEADER_NAME)

.PHONY: allopt opt.opt # allopt and opt.opt are synonyms
allopt: stdlib.cmxa std_exit.cmx
opt.opt: allopt

INSTALL_STDLIB_META_DIR=$(DESTDIR)$(LIBDIR)/stdlib

.PHONY: install
install::
	$(INSTALL_DATA) \
	  stdlib.cma std_exit.cmo *.cmi "$(INSTALL_LIBDIR)"
	$(MKDIR) "$(INSTALL_STDLIB_META_DIR)"
	$(INSTALL_DATA) META "$(INSTALL_STDLIB_META_DIR)"
ifeq "$(INSTALL_SOURCE_ARTIFACTS)" "true"
	$(INSTALL_DATA) \
	  *.cmt *.cmti *.mli *.ml *.ml.in \
	  "$(INSTALL_LIBDIR)"
endif
	$(INSTALL_DATA) target_$(HEADER_NAME) "$(INSTALL_LIBDIR)/$(HEADER_NAME)"

.PHONY: installopt
installopt: installopt-default

.PHONY: installopt-default
installopt-default:
	$(INSTALL_DATA) \
	  stdlib.cmxa stdlib.$(A) std_exit.$(O) *.cmx \
	  "$(INSTALL_LIBDIR)"

ifeq "$(UNIX_OR_WIN32)" "unix"
HEADERPROGRAM = header
else # Windows
HEADERPROGRAM = headernt
endif

%-launch-info: %.info tmpheader.exe
	@cat $^ >> $@

.INTERMEDIATE: tmpheader.exe
tmpheader.exe: $(HEADERPROGRAM).$(O)
	$(V_MKEXE)$(call MKEXE_VIA_CC,$@,$^)
	$(STRIP) $@

stdlib.cma: $(OBJS)
	$(V_LINKC)$(CAMLC) -a -o $@ $^

stdlib.cmxa: $(OBJS:.cmo=.cmx)
	$(V_LINKOPT)$(CAMLOPT) -a -o $@ $^

.PHONY: distclean
distclean: clean
	rm -f sys.ml META runtime.info target_runtime.info

.PHONY: clean
clean::
	rm -f $(HEADER_NAME) target_$(HEADER_NAME)

export AWK

%.cmi: %.mli
	$(V_OCAMLC)$(CAMLC) $(COMPFLAGS) $(shell ./Compflags $@) -c $<

# The dependency on the .mli file is in .depend (since stdlib__Foo.cmi
# depends on stdlib__foo.mli)
stdlib__%.cmi:
	$(V_OCAMLC)$(CAMLC) $(COMPFLAGS) $(shell ./Compflags $@) \
	         -o $@ -c $(filter %.mli, $^)

%.cmo: %.ml
	$(V_OCAMLC)$(CAMLC) $(COMPFLAGS) $(shell ./Compflags $@) -c $<

# The dependency on the .ml file is in .depend (since stdlib__Foo.cmo
# depends on stdlib__foo.ml)
stdlib__%.cmo:
	$(V_OCAMLC)$(CAMLC) $(COMPFLAGS) $(shell ./Compflags $@) \
	         -o $@ -c $(filter %.ml, $^)

%.cmx: %.ml
	$(V_OCAMLOPT)$(CAMLOPT) $(COMPFLAGS) $(OPTCOMPFLAGS) $(shell ./Compflags $@) -c $<

# The dependency on the .ml file is in .depend (since stdlib__Foo.cmx
# depends on stdlib__foo.ml)
stdlib__%.cmx:
	$(V_OCAMLOPT)$(CAMLOPT) $(COMPFLAGS) $(OPTCOMPFLAGS) $(shell ./Compflags $@) \
	           -o $@ -c $(filter %.ml, $^)

# Dependencies on the compiler
COMPILER_DEPS=$(filter-out $(OCAMLRUN), $(CAMLC))
$(OBJS) std_exit.cmo: $(COMPILER_DEPS)
$(OBJS:.cmo=.cmi) std_exit.cmi: $(COMPILER_DEPS)
$(OBJS:.cmo=.cmx) std_exit.cmx: $(OPTCOMPILER)

# Dependencies on Stdlib (not tracked by ocamlc -depend)

$(OTHERS) std_exit.cmo: stdlib.cmi
$(OTHERS:.cmo=.cmi) std_exit.cmi: stdlib.cmi
$(OBJS:.cmo=.cmx) std_exit.cmx: stdlib.cmi
$(OTHERS:.cmo=.cmx) std_exit.cmx: stdlib.cmx

clean::
	rm -f *.cm* *.o *.obj *.a *.lib *.odoc

include .depend

STDLIB_NAMESPACE_MODULES = $(subst $(SPACE),|,$(STDLIB_PREFIXED_MODULES))

GNUISH_SED = \
  $(if $(filter X,$(shell echo x | $(SED) -E -e 's/./\u&/' 2>/dev/null)),\
       $(SED),$(error GNU sed is needed for make depend))

.PHONY: depend
depend:
	$(V_OCAMLDEP){ \
	  $(OCAMLDEP_CMD) $(filter-out stdlib.%,$(wildcard *.mli *.ml)); \
	  $(OCAMLDEP_CMD) -pp "$(AWK) -f ./remove_module_aliases.awk" \
	  stdlib.ml stdlib.mli; \
	} | \
	$(GNUISH_SED) -E \
	-e 's/^(${STDLIB_NAMESPACE_MODULES})(\.[^i]*)(i?) :/\1\2\3 : \1.ml\3/' \
	-e 's#(^| )(${STDLIB_NAMESPACE_MODULES})[.]#\1stdlib__\u\2.#' \
	> .$@

=== testsuite/Makefile ===
#**************************************************************************
#*                                                                        *
#*                                 OCaml                                  *
#*                                                                        *
#*                 Xavier Clerc, SED, INRIA Rocquencourt                  *
#*                                                                        *
#*   Copyright 2010 Institut National de Recherche en Informatique et     *
#*     en Automatique.                                                    *
#*                                                                        *
#*   All rights reserved.  This file is distributed under the terms of    *
#*   the GNU Lesser General Public License version 2.1, with the          *
#*   special exception on linking described in the file LICENSE.          *
#*                                                                        *
#**************************************************************************

.NOTPARALLEL:

BASEDIR := $(shell pwd)
ifneq "$(words |$(BASEDIR)|)" "1"
$(error The Testsuite does not handle spaces\
   in the ocaml working directory path: $(BASEDIR))
endif

ROOTDIR = ..
include $(ROOTDIR)/Makefile.common

ifeq "$(UNIX_OR_WIN32)" "win32"
  CYGPATH=cygpath -m
  # Ensure that the test runners definitely use Cygwin's sort and not the
  # Windows sort command
  SORT=/usr/bin/sort
else
  CYGPATH=echo
  SORT=sort
endif

BASEDIR_HOST := $(shell $(CYGPATH) "$(BASEDIR)")
ROOTDIR_HOST := $(BASEDIR_HOST)/$(ROOTDIR)

OCAMLTESTDIR = $(BASEDIR_HOST)/$(DIR)/_ocamltest

failstamp := failure.stamp

TESTLOG ?= _log

ocamltest_directory := ../ocamltest

ocamltest_program := $(or \
  $(wildcard $(ocamltest_directory)/ocamltest.opt$(EXE)),\
  $(wildcard $(ocamltest_directory)/ocamltest$(EXE)))

ifeq "$(UNIX_OR_WIN32)" "unix"
  ifeq "$(SYSTEM)" "cygwin"
    find := /usr/bin/find
  else # Non-cygwin Unix
    find := find
  endif
  # $(IFS_LINE) for Unix simply clears IFS, so entire lines are read
  IFS_LINE = IFS=''
else # Windows
  find := /usr/bin/find
  # On Windows, ocamltest will produce Windows line-endings (\r\n) and the final
  # \r is kept by the shell. This can either be stripped with tr -d '\r' but we
  # can avoid the additional process by instead setting IFS in the while loop to
  # be the CR character (i.e. treat \r as a field delimiter).
  # The dance with $(CR_CHAR) is because POSIX doesn't provide a way to write \r
  # in a string.
  export CR_CHAR := $(shell printf "\r")
  IFS_LINE = IFS="$$CR_CHAR"
endif

ifeq "$(ocamltest_program)" ""
  ocamltest = $(error ocamltest not found in $(ocamltest_directory))
else
  ocamltest := SORT=$(SORT) MAKE=$(MAKE) $(ocamltest_program)
endif

# PROMOTE is only meant to be used internally in recursive calls;
# users should call the 'promote' target explicitly.
PROMOTE =
ifeq "$(PROMOTE)" ""
  OCAMLTEST_PROMOTE_FLAG =
else
  OCAMLTEST_PROMOTE_FLAG = -promote
endif

# KEEP_TEST_DIR_ON_SUCCESS should be set by the user (to a non-empty value)
# if they want to pass the -keep-test-dir-on-success option to ocamltest,
# to preserve test data of successful tests.

# KEEP is provided as a rather easier to remmber alias of
# KEEP_TEST_DIR_ON_SUCCESS, but to prevent the risk of naming conflict it's only
# recognised when used as make -C testsuite KEEP=1 ...
ifeq "$(origin KEEP)" "command line"
KEEP_TEST_DIR_ON_SUCCESS ?= $(KEEP)
else
KEEP_TEST_DIR_ON_SUCCESS ?=
endif

ifeq "$(KEEP_TEST_DIR_ON_SUCCESS)" ""
  OCAMLTEST_KEEP_TEST_DIR_ON_SUCCESS_FLAG =
else
  OCAMLTEST_KEEP_TEST_DIR_ON_SUCCESS_FLAG = -keep-test-dir-on-success
endif

TIMEOUT ?= 600 # 10 minutes

# SHOW_TIMINGS should be set by the user (to a non-empty value) if they want
# the timings for each test file to be included in the log
SHOW_TIMINGS ?=
OCAMLTEST_SHOW_TIMINGS_FLAG =
ifneq "$(SHOW_TIMINGS)" ""
ifeq "$(lib_unix)" "true"
  OCAMLTEST_SHOW_TIMINGS_FLAG = -show-timings
endif
endif

OCAMLTESTFLAGS = \
  -timeout $(TIMEOUT) \
  $(OCAMLTEST_PROMOTE_FLAG) \
  $(OCAMLTEST_KEEP_TEST_DIR_ON_SUCCESS_FLAG) \
  $(OCAMLTEST_SHOW_TIMINGS_FLAG)

# Make sure USE_RUNTIME is defined
USE_RUNTIME ?=

ifneq ($(USE_RUNTIME),)
# Check USE_RUNTIME value
ifeq ($(findstring $(USE_RUNTIME),d i),)
$(error If set, USE_RUNTIME must be equal to "d" (debug runtime) \
        or "i" (instrumented runtime))
endif
# When using the debug or instrumented runtime,
# set the runtime's verbosity to 0 by default
export OCAMLRUNPARAM?=v=0
endif

.PHONY: default
default:
	@echo "Available targets:"
	@echo "  all                        launch all tests"
	@echo "  all-foo                    launch all tests beginning with foo"
	@echo "  parallel                   launch all tests using GNU parallel"
	@echo "  parallel-foo               launch all tests beginning with foo using \
	GNU parallel"
	@echo "  one (TEST|DIR|LIST)=x      launch the specified tests ..."
	@echo "  promote (TEST|DIR|LIST)=x  promote the output for the specified \
	tests ..."
	@echo "    ... TEST=f                 ... the single test in the file f"
	@echo "    ... DIR=d                  ... the tests located in the directory d"
	@echo "    ... LIST=f                 ... the tests listed in the file f (one \
	per line)"
	@echo "  clean                      delete generated files"
	@echo "  report                     print the report for the last execution"
	@echo
	@echo "By default, artefacts from tests which pass are not kept, but this can"
	@echo "be changed by adding KEEP=1 to the make command line or by setting the"
	@echo "KEEP_TEST_DIR_ON_SUCCESS environment variable to a non-empty value."
	@echo
	@echo "Set the environment variable USE_RUNTIME to \"d\" or \"i\" to run"
	@echo "the tests with the debug or the instrumented runtime."

.PHONY: all
all:
	@$(MAKE) --no-print-directory new-without-report
	@$(MAKE) --no-print-directory report

.PHONY: new-without-report
new-without-report:
	@rm -f $(failstamp)
	@($(ocamltest) -find-test-dirs tests | while $(IFS_LINE) read -r dir; do \
	  echo Running tests from \'$$dir\' ... ; \
	  $(MAKE) exec-ocamltest DIR="$$dir" \
	    OCAMLTESTENV=""; \
	done || echo outer loop >> $(failstamp)) 2>&1 | tee $(TESTLOG)
	@$(MAKE) check-failstamp

.PHONY: check-failstamp
check-failstamp:
	@if [ -f $(failstamp) ]; then \
	  echo 'Unexpected error in the test infrastructure:'; \
	  cat $(failstamp); \
	  rm $(failstamp); \
	  exit 1; \
	fi

.PHONY: all-%
all-%:
	@for dir in tests/$**; do \
	  $(MAKE) --no-print-directory exec-one DIR=$$dir; \
	done 2>&1 | tee $(TESTLOG)
	@$(MAKE) report

# The targets below use GNU parallel to parallelize tests
# 'make all' and 'make parallel' should be equivalent
#
# parallel uses specific logic to make sure the output of the commands
# run in parallel are not mangled. By default, it will reproduce
# the output of each completed command atomically, in order of completion.
#
# With the --keep-order option, we ask it to save the completed output
# and replay them in invocation order instead. In theory this costs
# a tiny bit of performance, but I could not measure any difference.
# In theory again, the reporting logic works fine with test outputs
# coming in in arbitrary order (so we should not need --keep-order),
# but keeping the output deterministic is guaranteed to make
# someone's life easier at least once in the future.
#
# Finally, note that the command we run has a 2>&1 redirection, as
# in the other make targets. If we removed the quoting around
# "$(MAKE) ... 2>&1", the rediction would apply to the complete output
# of parallel, and have a slightly different behavior: by default parallel
# cleanly separates the stdout and stderr output of each completed command,
# printing stderr first then stdout second (for each command).
# I chose to keep the previous behavior exactly unchanged,
# but the demangling separation is arguably nicer behavior that we might
# want to implement at the exec-one level to also have it in the 'all' target.

# If make has been invoked with "-j n", pass this on to GNU parallel. parallel
# does not support -j without an argument, hence the double-filter. Note that
# GNU make normalises -j in $(MAKEFLAGS) so it will either be -j alone or -jn
# (i.e. with no space).
J_ARGUMENT = $(filter-out -j,$(filter -j%,$(MAKEFLAGS)))

.PHONY: parallel-%
parallel-%:
	@echo | parallel >/dev/null 2>/dev/null \
	 || (echo "Unable to run the GNU parallel tool;";\
	     echo "You should install it before using the parallel* targets.";\
	     exit 1)
	@echo | parallel --gnu --no-notice >/dev/null 2>/dev/null \
	 || (echo "Your 'parallel' tool seems incompatible with GNU parallel.";\
	     echo "This target requires GNU parallel.";\
	     exit 1)
	@for dir in tests/$**; do echo $$dir; done \
	 | parallel --gnu --no-notice --keep-order $(J_ARGUMENT) \
	     "$(MAKE) --no-print-directory exec-one DIR={} 2>&1" \
	 | tee $(TESTLOG)
	@$(MAKE) report

.PHONY: parallel
parallel: parallel-*

.PHONY: list
list:
	@if [ -z "$(FILE)" ]; \
    then echo "No value set for variable 'FILE'."; \
    exit 1; \
  fi
	@$(MAKE) --no-print-directory one LIST="$(FILE)"

.PHONY: one
one:
	@case "$(words $(DIR) $(LIST) $(TEST))" in \
   0) echo 'No value set for variable DIR, LIST or TEST'>&2; exit 1;; \
   1) exit 0;; \
   *) echo 'Please specify exactly one of DIR, LIST or TEST'>&2; exit 1;; \
   esac
	@if [ -n '$(DIR)' ] && [ ! -d '$(DIR)' ]; then \
    echo "Directory '$(DIR)' does not exist."; exit 1; \
  fi
	@if [ -n '$(TEST)' ] && [ ! -e '$(TEST)' ]; then \
    echo "Test '$(TEST)' does not exist."; exit 1; \
  fi
	@if [ -n '$(LIST)' ] && [ ! -e '$(LIST)' ]; then \
    echo "File '$(LIST)' does not exist."; exit 1; \
  fi
	@if [ -n '$(DIR)' ] ; then \
    $(MAKE) --no-print-directory exec-one DIR=$(DIR) \
      2>&1 | tee $(TESTLOG).one ; \
   fi
	@if [ -n '$(TEST)' ] ; then \
    TERM=dumb $(OCAMLTESTENV) $(ocamltest) $(OCAMLTESTFLAGS) $(TEST) \
     2>&1 | tee $(TESTLOG).one; fi
	@if [ -n '$(LIST)' ] ; then \
     while IFS='' read -r LINE; do \
       $(MAKE) --no-print-directory exec-one DIR=$$LINE ; \
     done < $$LIST 2>&1 | tee $(TESTLOG).one ; \
   fi
	@$(MAKE) check-failstamp
	@$(MAKE) TESTLOG=$(TESTLOG).one report

.PHONY: exec-one
exec-one:
	@$(ocamltest) -find-test-dirs $(DIR) | while $(IFS_LINE) read -r dir; do \
	  echo "Running tests from '$$dir' ..."; \
	  $(MAKE) exec-ocamltest DIR="$$dir" \
	    OCAMLTESTENV="OCAMLTESTDIR=$(OCAMLTESTDIR)"; \
	done

.PHONY: exec-ocamltest
exec-ocamltest:
	@if [ -z "$(DIR)" ]; then exit 1; fi
	@if [ ! -d "$(DIR)" ]; then exit 1; fi
	@($(ocamltest) -list-tests $(DIR) | while $(IFS_LINE) read -r testfile; do \
	   TERM=dumb $(OCAMLTESTENV) \
	     $(ocamltest) $(OCAMLTESTFLAGS) "$(DIR)/$$testfile" || \
	   echo " ... testing '$$testfile' => unexpected error"; \
	done) || echo directory "$(DIR)" >>$(failstamp)

.PHONY: clean-one
clean-one:
	@if [ ! -f $(DIR)/Makefile ]; then \
	  for dir in $(DIR)/*; do \
	    if [ -d $$dir ]; then \
	      $(MAKE) clean-one DIR=$$dir; \
	    fi; \
	  done; \
	else \
	  cd $(DIR) && $(MAKE) TERM=dumb BASEDIR=$(BASEDIR) clean; \
	fi

.PHONY: promote
promote:
	@$(MAKE) one PROMOTE=true

.PHONY: clean
clean:
	find . -name '*_ocamltest*' | xargs rm -rf
	rm -f $(failstamp)

.PHONY: distclean
distclean: clean
	rm -f _log*

.PHONY: report
report:
	@if [ ! -f $(TESTLOG) ]; then echo "No $(TESTLOG) file."; exit 1; fi
	@$(AWK) -f ./summarize.awk < $(TESTLOG)

=== api_docgen/ocamldoc/Makefile ===
#**************************************************************************
#*                                                                        *
#*                                 OCaml                                  *
#*                                                                        *
#*             Florian Angeletti, projet Cambium, Inria Paris             *
#*                                                                        *
#*   Copyright 2020 Institut National de Recherche en Informatique et     *
#*     en Automatique.                                                    *
#*                                                                        *
#*   All rights reserved.  This file is distributed under the terms of    *
#*   the GNU Lesser General Public License version 2.1, with the          *
#*   special exception on linking described in the file LICENSE.          *
#*                                                                        *
#**************************************************************************
# Used by included Makefiles
ROOTDIR = ../..
include ../Makefile.common
vpath %.mli ../../stdlib $(DOC_COMPILERLIBS_DIRS)  $(DOC_STDLIB_DIRS)


man: build/man/Stdlib.3o
latex: build/latex/Stdlib.tex
html: \
  build/html/libref/Stdlib.html \
  build/html/compilerlibref/Compiler_libs.html
texi: build/texi/stdlib.texi

DOC_STDLIB_INCLUDES= $(addprefix -I , $(DOC_STDLIB_DIRS))

DOC_ALL_INCLUDES = \
  $(DOC_STDLIB_INCLUDES) \
  $(addprefix -I ,$(DOC_COMPILERLIBS_DIRS))

libref=$(stdlib_UNPREFIXED) $(otherlibref)

ALL_MAN= $(ALL_DOC:%=build/man/%.3o)
ALL_LATEX= $(ALL_DOC:%=build/latex/%.tex)

build/latex/ifocamldoc.tex: | build/latex
	$(V_GEN)printf '\\newif\\ifocamldoc\\ocamldoctrue\n' > $@

$(libref:%=build/libref/%.odoc): build/libref/%.odoc: %.mli | build/libref
	$(V_OCAMLDOC)$(OCAMLDOC_RUN) -nostdlib -hide Stdlib -lib Stdlib \
	-pp \
"$(AWK) -v ocamldoc=true -f ../../stdlib/expand_module_aliases.awk" \
	$(DOC_STDLIB_INCLUDES) -hide-warnings $< -dump  $@

$(compilerlibref:%=build/compilerlibref/%.odoc):\
build/compilerlibref/%.odoc: %.mli | build/compilerlibref
	$(V_OCAMLDOC)$(OCAMLDOC_RUN) -nostdlib -hide Stdlib \
	$(DOC_ALL_INCLUDES) -hide-warnings $< -dump  $@

$(compilerlibref_TEXT:%=build/compilerlibref/%.odoc):\
build/compilerlibref/%.odoc: build/%.mld | build/compilerlibref
	$(V_OCAMLDOC)$(OCAMLDOC_RUN)  -hide-warnings $(DOC_ALL_INCLUDES) -text $< -dump  $@

$(libref_TEXT:%=build/libref/%.odoc):\
build/libref/%.odoc: build/%.mld | build/libref
	$(V_OCAMLDOC)$(OCAMLDOC_RUN) -hide-warnings $(DOC_STDLIB_INCLUDES) -text $< -dump  $@

ALL_COMPILED_DOC=$(ALL_DOC:%=build/%.odoc)
build/man/Stdlib.3o: $(ALL_COMPILED_DOC) | build/man
	$(V_OCAMLDOC)$(OCAMLDOC_RUN) -man -d build/man -man-mini \
	-nostdlib -hide Stdlib -lib Stdlib -t "OCaml library" \
	$(addprefix -load , $(ALL_COMPILED_DOC))

HTML_OPTIONS= -charset="utf8" -colorize-code -nonavbar

build/html/libref/Stdlib.html: $(ALL_LIBREF:%=build/%.odoc) | build/html/libref
	$(V_OCAMLDOC)$(OCAMLDOC_RUN) -html -d build/html/libref \
	$(HTML_OPTIONS) \
	-nostdlib -hide Stdlib -lib Stdlib -t "OCaml library" \
	$(addprefix -load , $(ALL_LIBREF:%=build/%.odoc))

build/html/compilerlibref/Compiler_libs.html: \
  $(ALL_COMPILERLIBREF:%=build/%.odoc) | build/html/compilerlibref
	$(V_OCAMLDOC)$(OCAMLDOC_RUN) -html -d build/html/compilerlibref \
	-nostdlib -hide Stdlib -t "OCaml compiler library" \
	$(HTML_OPTIONS) \
	-intro build/Compiler_libs.mld \
	$(addprefix -load , $(ALL_COMPILERLIBREF:%=build/%.odoc))

build/texi/stdlib.texi: $(ALL_COMPILED_DOC) | build/texi
	$(V_OCAMLDOC)$(OCAMLDOC_RUN) -texi -o $@ \
	-nostdlib -hide Stdlib -lib Stdlib -t "OCaml library" \
	$(addprefix -load , $(ALL_COMPILED_DOC))

build/latex/Stdlib.tex: $(ALL_COMPILED_DOC) | build/latex
	$(V_OCAMLDOC)$(OCAMLDOC_RUN) -latex -o build/latex/all.tex \
	-hide Stdlib -lib Stdlib $(DOC_ALL_INCLUDES) \
	-sepfiles \
	-latex-escape-underscore "false" \
	-latextitle "1,subsection*" \
	-latextitle "2,subsubsection*" \
	-latex-type-prefix "TYP" \
	-latex-module-prefix "" \
	-latex-module-type-prefix "" \
	-latex-value-prefix "" \
	-nostdlib -hide Stdlib -lib Stdlib -t "OCaml library" \
	$(addprefix -load , $(ALL_COMPILED_DOC))

build/latex/alldoc.pdf: build/latex/Stdlib.tex build/latex/alldoc.tex \
  | build/latex
	cd build/latex && \
          TEXINPUTS=$${TEXINPUTS}:../../ocamldoc pdflatex alldoc
	cd build/latex && \
	  TEXINPUTS=$${TEXINPUTS}:../../ocamldoc pdflatex alldoc

stdlib_INPUT=$(foreach module,\
$(filter-out stdlib.mli camlinternal%,$(stdlib_UNPREFIXED)),\
\\input{$(call capitalize,$(module)).tex}\
)
build/latex/stdlib_input.tex: | build/latex
	$(V_GEN)echo $(stdlib_INPUT) > $@

compilerlibs_INPUT=$(foreach module,\
$(filter-out camlinternal%,$(compilerlibref)),\
\\input{$(call capitalize,$(module)).tex})
build/latex/compilerlibs_input.tex: | build/latex
	$(V_GEN)echo $(compilerlibs_INPUT) > $@

.PHONY: install
install:
	$(MKDIR) "$(INSTALL_LIBRARIES_MAN_DIR)"
	if test -d build/man; then \
	  $(INSTALL_DATA) build/man/*.3o "$(INSTALL_LIBRARIES_MAN_DIR)"; \
	fi

=== manual/tests/Makefile ===
ROOTDIR = ../..
include $(ROOTDIR)/api_docgen/Makefile.docfiles
include $(ROOTDIR)/Makefile.common
include $(ROOTDIR)/stdlib/StdlibModules
include $(ROOTDIR)/Makefile.best_binaries
OCAMLC ?= $(BEST_OCAMLC) $(STDLIBFLAGS)

MANUAL=$(ROOTDIR)/manual/src

.PHONY: all
all: check-cross-references check-stdlib check-case-collision

.PHONY: tools
tools: cross-reference-checker

cross-reference-checker: cross_reference_checker.ml
	$(OCAMLC) $(ROOTDIR)/compilerlibs/ocamlcommon.cma \
	  -I $(ROOTDIR)/utils -I $(ROOTDIR)/parsing -I $(ROOTDIR)/driver \
	  $< -o $@

# check cross-references between the manual and error messages
.PHONY: check-cross-references
check-cross-references: cross-reference-checker
	$(OCAMLRUN) ./cross-reference-checker \
	  -auxfile $(MANUAL)/texstuff/manual.aux \
	  $(ROOTDIR)/utils/warnings.ml \
	  $(ROOTDIR)/driver/main_args.ml \
	  $(ROOTDIR)/lambda/translmod.ml \
	  $(ROOTDIR)/typing/typemod.ml \
	  $(ROOTDIR)/typing/typeclass.ml

# check that all standard library modules are referenced by the
# standard library chapter of the manual
.PHONY: check-stdlib
check-stdlib:
	./check-stdlib-modules $(ROOTDIR)


# check name collision between latex source file and module documentation
# on case-insensitive file systems
normalize = $(shell echo $(basename $(notdir $(1) )) | tr A-Z a-z)
LOWER_MLIS= $(call normalize,$(ALL_DOC:%=%.mli))
LOWER_ETEX= $(call normalize,$(wildcard $(MANUAL)/*/*.etex) $(wildcard *.etex))
INTER = $(filter $(LOWER_ETEX), $(LOWER_MLIS))

.PHONY: check-case-collision
check-case-collision:
ifeq ($(INTER),)
	@echo "No collisions detected between OCaml modules and LaTeX sources."
else
	@echo "The following names"
	@echo "  $(INTER)"
	@echo "are used by both an OCaml module and a latex source file."
	@echo "This creates a conflict on case-insensitive file systems."
	@false
endif


.PHONY: clean
clean:
	rm -f *.cm? *.cmx? cross-reference-checker

.PHONY: distclean
distclean: clean

=== manual/tools/Makefile ===
ROOTDIR = ../..
include $(ROOTDIR)/Makefile.common
include $(ROOTDIR)/Makefile.best_binaries

OCAMLC ?= $(BEST_OCAMLC) $(STDLIBFLAGS)

all: texquote2 transf


transf: transf.cmo transfmain.cmo
	$(OCAMLC) $(COMPFLAGS) -o $@ -g $^

transfmain.cmo: transf.cmo

texquote2: texquote2.ml
	$(OCAMLC) $(COMPFLAGS) -o $@ $<

%.cmo: %.ml
	$(OCAMLC) $(COMPFLAGS) -c $<

%.cmi: %.mli
	$(OCAMLC) $(COMPFLAGS) -c $<

.PHONY: clean
clean:
	rm -f *.o *.cm? *.cmx?
	rm -f transf.ml
	rm -f texquote2 transf

.PHONY: distclean
distclean: clean

=== otherlibs/runtime_events/Makefile ===
#**************************************************************************
#*                                                                        *
#*                                 OCaml                                  *
#*                                                                        *
#*            Xavier Leroy, projet Cristal, INRIA Rocquencourt            *
#*                                                                        *
#*   Copyright 1999 Institut National de Recherche en Informatique et     *
#*     en Automatique.                                                    *
#*                                                                        *
#*   All rights reserved.  This file is distributed under the terms of    *
#*   the GNU Lesser General Public License version 2.1, with the          *
#*   special exception on linking described in the file LICENSE.          *
#*                                                                        *
#**************************************************************************

# Makefile for the runtime events library

LIBNAME=runtime_events
CLIBNAME=camlruntime_events
CAMLOBJS=runtime_events.cmo
C_SOURCES=runtime_events_consumer.c
HEADERS=caml/runtime_events_consumer.h

include ../Makefile.otherlibs.common
runtime_events.cmo: runtime_events.cmi
runtime_events.cmx: runtime_events.cmi

.PHONY: depend
depend:
	$(OCAMLRUN) $(ROOTDIR)/boot/ocamlc -depend -slash *.mli *.ml > .depend

include .depend

=== otherlibs/unix/Makefile ===
#**************************************************************************
#*                                                                        *
#*                                 OCaml                                  *
#*                                                                        *
#*            Xavier Leroy, projet Cristal, INRIA Rocquencourt            *
#*                                                                        *
#*   Copyright 1999 Institut National de Recherche en Informatique et     *
#*     en Automatique.                                                    *
#*                                                                        *
#*   All rights reserved.  This file is distributed under the terms of    *
#*   the GNU Lesser General Public License version 2.1, with the          *
#*   special exception on linking described in the file LICENSE.          *
#*                                                                        *
#**************************************************************************

# Makefile for the Unix interface library

ROOTDIR = ../..
# Note: at the moment, we need to include the configuration makefile directly
# even before we can include Makefile.otherlibs.common
# because the UNIX_OR_WIN32 variable must be defined even before
# we can include Makefile.otherlibs.common
# This will be fixed later
include $(ROOTDIR)/Makefile.config_if_required

LIBNAME=unix

EXTRACAMLFLAGS=-nolabels

# This flag is used to disable compatibility definitions in header files to
# ensure that they're not accidentally used in the library itself.
OC_CPPFLAGS += -DCAML_BUILDING_UNIX

unixLabels.cmi: \
  EXTRACAMLFLAGS += -pp "$(AWK) -f $(ROOTDIR)/stdlib/expand_module_aliases.awk"

ifeq "$(UNIX_OR_WIN32)" "win32"
WIN32_LIBS=$(call SYSLIB,ws2_32) $(call SYSLIB,advapi32)
LINKOPTS=$(addprefix -cclib ,$(WIN32_LIBS))
LDOPTS=$(addprefix -ldopt ,$(WIN32_LIBS))
else # Unix
# dllunix.so particularly requires libm for modf symbols
LDOPTS=$(NATIVECCLIBS)
endif

# C source files common to both Unix and Windows
COMMON_C_SOURCES = $(addsuffix .c, \
  access addrofstr chdir chmod cst2constr cstringv execv execve execvp fsync \
  mkdir exit getaddrinfo getcwd gethost gethostname getnameinfo getproto \
  getserv gmtime mmap_ba putenv rmdir socketaddr strofaddr time unlink)

# OS-specific C source files
OS_C_SOURCES = $(addsuffix _$(UNIX_OR_WIN32).c, \
  accept bind channels close connect dup envir errmsg getpeername getpid \
  getsockname gettimeofday isatty link listen lockf lseek mmap open pipe \
  read readlink realpath rename select sendrecv shutdown sleep socket \
  socketpair sockopt stat symlink times truncate unixsupport utimes write)

# OS-specific modules that have no counterpart on the other OS
ifeq "$(UNIX_OR_WIN32)" "win32"
OS_C_SOURCES += $(addsuffix .c, \
  close_on createprocess nonblock startup system windbug windir winlist \
  winwait winworker)
else
OS_C_SOURCES += $(addsuffix .c, \
  alarm chown chroot closedir dup2 fchmod fchown fcntl fork ftruncate \
  getegid geteuid getgid getgr getgroups getlogin getppid getpw getuid \
  initgroups itimer kill mkfifo nice opendir readdir rewinddir setgid \
  setgroups setsid setuid signals spawn termios umask wait)
endif

C_SOURCES = $(COMMON_C_SOURCES) $(OS_C_SOURCES)

CAMLOBJS=unix.cmo unixLabels.cmo

HEADERS=$(addprefix caml/, unixsupport.h socketaddr.h)

include ../Makefile.otherlibs.common

distclean::
	rm -f unix.ml

.PHONY: depend
depend:
	$(OCAMLDEP_CMD) *.mli *.ml > .depend

include .depend

=== debian/changelog ===
ocaml (5.4.0-1~exp1) experimental; urgency=medium

  * New upstream release
  * Build --without-zstd
  * Switch debian/watch to version 5
  * Bump Standards-Version to 4.7.2

 -- Stéphane Glondu <glondu@debian.org>  Sun, 12 Oct 2025 12:31:14 +0200

ocaml (5.3.0-3) unstable; urgency=medium

  * Mark tests that actually require multicore (Closes: #1101353)
  * Do not run flaky test (Closes: #1103008)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 12 Jun 2025 14:08:28 +0200

=== debian/control ===
Source: ocaml
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Ralf Treinen <treinen@debian.org>,
 Stéphane Glondu <glondu@debian.org>,
 Mehdi Dogguy <mehdi@debian.org>,
 Ximin Luo <infinity0@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 pkgconf,
 binutils-dev,
 libiberty-dev,
 libncurses-dev,
 zlib1g-dev,
 dh-ocaml
Build-Conflicts: ocaml-base
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml
Homepage: https://ocaml.org/

# This needs to stay at the top - we symlink docs to the copy in this package,
# and dh_installdocs installs README.Debian etc into the first package listed.
Package: ocaml-base
Architecture: any
Depends:
 libstdlib-ocaml (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 ocaml-base-${F:OCamlABI}
Breaks: ocaml-base-nox (<< 4.13)
Replaces: ocaml-base-nox (<< 4.13)
Description: Runtime system for OCaml bytecode executables
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains only the runtime system needed to run bytecode
 executables. The 'ocaml' package contains the full development suite of
 Objective Caml.

Package: ocaml
Architecture: any
Depends:
 ocaml-interp (= ${binary:Version}),
 libncurses-dev,
 gcc,
 binutils,
 libzstd-dev,
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 ocaml-${F:OCamlABI},
 ocaml-best-compilers (= ${binary:Version}),
 ${F:NativeProvides}
Suggests:
 ocaml-doc,
 elpa-tuareg
Recommends:
 ocaml-man,
 file
Breaks: ocaml-nox (<< 4.13)
Replaces: ocaml-nox (<< 4.13)
Description: ML language implementation with a class-based object system
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 OCaml comprises two compilers. One generates bytecode
 which is then interpreted by a C program. This compiler runs quickly,
 generates compact code with moderate memory requirements, and is
 portable to essentially any 32 or 64 bit Unix platform. Performance of
 generated programs is quite good for a bytecoded implementation:
 almost twice as fast as Caml Light 0.7. This compiler can be used
 either as a standalone, batch-oriented compiler that produces
 standalone programs, or as an interactive, toplevel-based system.
 .
 The other compiler generates high-performance native code for a number
 of processors. Compilation takes longer and generates bigger code, but
 the generated programs deliver excellent performance, while retaining
 the moderate memory requirements of the bytecode compiler. It is not
 available on all arches though.
 .
 This package contains everything needed to develop OCaml applications.

Package: libstdlib-ocaml-dev
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 libseq-ocaml-dev,
 libuchar-ocaml-dev,
 libstdlib-shims-ocaml-dev,
 ${ocaml:Provides}
Recommends:
 ocaml-man
Breaks:
 libfindlib-ocaml (<< 1.9.6-3~),
 ocaml (<< 4.13.1-5~),
 ocaml-base (<< 4.13.1-5~),
 ocaml-compiler-libs (<< 4.13.1-5~)
Replaces:
 libfindlib-ocaml (<< 1.9.6-3~),
 ocaml (<< 4.13.1-5~),
 ocaml-base (<< 4.13.1-5~),
 ocaml-compiler-libs (<< 4.13.1-5~)
Description: OCaml standard library (development files)
 OCaml is an implementation of the ML language, based on the Caml
 Light dialect extended with a complete class-based object system and
 a powerful module system in the style of Standard ML.
 .
 This package contains the development files of the standard library.

Package: libstdlib-ocaml
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 libseq-ocaml,
 libuchar-ocaml,
 libstdlib-shims-ocaml,
 ${ocaml:Provides}
Breaks:
 libfindlib-ocaml (<< 1.9.6-3~),
 ocaml (<< 4.13.1-5~),
 ocaml-base (<< 4.13.1-5~),
 ocaml-compiler-libs (<< 4.13.1-5~),
 dh-ocaml (<< 2)
Replaces:
 libfindlib-ocaml (<< 1.9.6-3~),
 ocaml (<< 4.13.1-5~),
 ocaml-base (<< 4.13.1-5~),
 ocaml-compiler-libs (<< 4.13.1-5~)
Description: OCaml standard library (runtime files)
 OCaml is an implementation of the ML language, based on the Caml
 Light dialect extended with a complete class-based object system and
 a powerful module system in the style of Standard ML.
 .
 This package contains the runtime files of the standard library.

Package: libcompiler-libs-ocaml-dev
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 ${ocaml:Provides}
Breaks:
 libfindlib-ocaml (<< 1.9.6-3~),
 ocaml (<< 4.13.1-5~),
 ocaml-base (<< 4.13.1-5~),
 ocaml-compiler-libs (<< 4.13.1-5~)
Replaces:
 libfindlib-ocaml (<< 1.9.6-3~),
 ocaml (<< 4.13.1-5~),
 ocaml-base (<< 4.13.1-5~),
 ocaml-compiler-libs (<< 4.13.1-5~)
Description: OCaml compiler library (development files)
 OCaml is an implementation of the ML language, based on the Caml
 Light dialect extended with a complete class-based object system and
 a powerful module system in the style of Standard ML.
 .
 This package contains the development files of the compiler library.

Package: ocaml-source
Architecture: all
Depends: ${misc:Depends}
Provides: ocaml-source-${F:OCamlABI}
Description: Sources for Objective Caml
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains the sources needed to build some packages which build
 depend on the OCaml source. Notice that if you want to rebuild OCaml, these
 will not work, consider using the source package instead.

Package: ocaml-interp
Architecture: any
Depends:
 ocaml-base (= ${binary:Version}),
 libcompiler-libs-ocaml-dev (= ${binary:Version}),
 ${ocaml:Depends},
 ${misc:Depends}
Provides:
 ocaml-interp-${F:OCamlABI}
Recommends: ledit | readline-editor
Description: OCaml interactive interpreter and standard libraries
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains the files required to run an OCaml shell from the
 command line.

Package: ocaml-man
Architecture: all
Depends:
 ${misc:Depends}
Breaks:
 ocaml (<< 4.08),
 ocaml-nox (<< 4.08),
 ocaml-compiler-libs (<< 4.08)
Replaces:
 ocaml (<< 4.08),
 ocaml-nox (<< 4.08),
 ocaml-compiler-libs (<< 4.08)
Description: OCaml interpreter and standard libraries (lib manpages)
 Objective (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains ocamldoc-generated documentation about libraries
 provided by OCaml.

Package: ocaml-base-nox
Section: oldlibs
Architecture: all
Depends:
 ocaml-base,
 ${misc:Depends}
Replaces: ocaml-base (<< 4.08), ocaml-nox (<< 4.08)
Breaks: ocaml-base (<< 4.08), ocaml-nox (<< 4.08)
Description: transitional package for ocaml-base
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This is a transitional package and can be safely removed.

Package: ocaml-nox
Section: oldlibs
Architecture: all
Depends:
 ocaml,
 ${misc:Depends}
Replaces: ocaml-base-nox (<< 4.08), ocaml-compiler-libs (<< 4.08)
Breaks: ocaml-base-nox (<< 4.08), ocaml-compiler-libs (<< 4.08)
Description: transitional package for ocaml
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This is a transitional package and can be safely removed.

Package: ocaml-compiler-libs
Section: oldlibs
Architecture: all
Depends:
 libcompiler-libs-ocaml-dev,
 ${misc:Depends}
Replaces: ocaml-base-nox (<< 4)
Breaks: ocaml-base-nox (<< 4)
Description: transitional package for libcompiler-libs-ocaml-dev
 Objective (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This is a transitional package and can be safely removed.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk

PACKAGE := ocaml
ALL_PACKAGES := $(shell dh_listpackages)

# Can't use /usr/share/ocaml/ocamlvars.mk because it tries to run ocamlc
include $(CURDIR)/debian/ocamlvars.mk

# Use ccache if pkg.ocaml.ccache build-profile is active.
ifneq (,$(filter pkg.ocaml.ccache,$(DEB_BUILD_PROFILES)))
export PATH := /usr/lib/ccache:$(PATH)
export CCACHE_DIR := $(CURDIR)/debian/ccache
#export CCACHE_BASEDIR := $(CURDIR)/debian/build
$(shell mkdir -p "$(CCACHE_DIR)")
endif

# Build cache (for Debian debugging)
BUILDCACHE := $(wildcard ../ocaml.cache)

MD5SUMSDIR = /var/lib/ocaml/md5sums
INSTDIR = $(CURDIR)/debian/tmp/usr
DISTDIR = $(PACKAGE)-$(OCAML_ABI)
UPSTREAM_VERSION = $(shell dpkg-parsechangelog | awk '/^Version:/{print $$2}' | { read u; echo $${u%-*}; })
UPSTREAM_TARBALL = $(wildcard ../$(PACKAGE)_$(UPSTREAM_VERSION).orig.tar.*)
SRCTARBALL = $(PACKAGE)-source-$(OCAML_ABI).tar

TESTDIR := debian/test-build
TESTRULES := debian/rules DEB_TEST_BUILD_PREFIX=$(CURDIR)/$(TESTDIR)

BUILD_DATE := $(shell dpkg-parsechangelog --show-field=Date)

ifeq (,$(DEB_TEST_BUILD_PREFIX))
ifneq (,$(findstring ocaml-source,$(ALL_PACKAGES)))
  TARBALL_TARGET = debian/$(SRCTARBALL)
endif
endif

# Environment variable for dh_ocaml
export OCAMLOBJINFO = OCAMLLIB=tools boot/ocamlrun tools/ocamlobjinfo

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_OPTIONS

# This has to be exported to make dispatch work
export OCAML_OPT_ARCH
export OCAML_STDLIB_DIR

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow
export CCLINKFLAGS=$(shell dpkg-buildflags --get LDFLAGS)

CONFIGURE_OPTS := \
  --without-zstd \
  --enable-ocamltest \
  --host $(DEB_BUILD_GNU_TYPE)\
  -prefix $(DEB_TEST_BUILD_PREFIX)/usr \
  -libdir $(DEB_TEST_BUILD_PREFIX)$(OCAML_STDLIB_DIR) \
  -mandir $(DEB_TEST_BUILD_PREFIX)/usr/share/man \

# Upstream recommends dropping support on armel, see https://github.com/ocaml/ocaml/issues/7642
# Binaries generated by ocamlopt segfault on x32
# ld reports spurious messages on powerpc, see https://github.com/ocaml/ocaml/issues/8846
ifeq (,$(OCAML_OPT_ARCH))
CONFIGURE_OPTS += --disable-native-compiler
endif

# fma does not work on m68k, enable emulation as instructed by configure script
ifeq (m68k,$(DEB_BUILD_ARCH))
CONFIGURE_OPTS += --enable-imprecise-c99-float-ops
IGNORE_TESTS_FAILURE := || true
else ifneq (,$(findstring hurd,$(DEB_BUILD_ARCH)))
IGNORE_TESTS_FAILURE := || true
else
IGNORE_TESTS_FAILURE :=
endif

# To avoid Lintian's file-references-package-build-path
export BUILD_PATH_PREFIX_MAP=.=$(CURDIR)

%:
	dh $@

# Needed because there is a "build" in the upstream tarball
.PHONY: build
build:
	dh $@

pre-config-stamp: $(TARBALL_TARGET)
# Backup upstream config.{sub,guess}, and use most up-to-date ones
	set -e; for ext in sub guess; do \
	  if [ -f /usr/share/misc/config.$$ext ] && \
	    ! [ -f debian/config.orig.$$ext ]; then \
	    mv build-aux/config.$$ext debian/config.orig.$$ext; \
	    cp -f /usr/share/misc/config.$$ext build-aux/config.$$ext; \
	  fi; \
	done
# Debian kfreebsd has non-working shims for dup3/pipe2, see #827935. Upstream
# ./configure isn't sophisticated enough to detect this so patch it out here.
ifeq (kfreebsd,$(DEB_HOST_ARCH_OS))
	sed -i -e '/HAS_DUP3/d' -e '/HAS_PIPE2/d' ./configure
endif
	touch $@

ifneq (,$(TARBALL_TARGET))
$(TARBALL_TARGET): $(UPSTREAM_TARBALL)
	mkdir -p debian/$(DISTDIR)
# Copy upstream tarball
	cp $< debian/$(DISTDIR)
# Copy debian/patches
	cp -a debian/patches debian/$(DISTDIR)/debian-patches
# Set permissions (workaround for #796257)
	chmod 755 debian/$(DISTDIR)/debian-patches
	chmod 644 debian/$(DISTDIR)/debian-patches/*
# Create the tarball and cleanup
	cd debian && find $(DISTDIR) -not -type d -print0 | \
		LC_ALL=C sort --zero-terminated | \
		tar --create --null --files-from=- \
			--file=$(abspath $@) --mtime="$(BUILD_DATE)" \
			--owner=root --group=root --numeric-owner
	rm -Rf debian/$(DISTDIR)
endif

.PHONY: override_dh_auto_configure
override_dh_auto_configure: config-stamp ocamlinit-stamp

config-stamp: pre-config-stamp
	./configure $(CONFIGURE_OPTS)
	sed -r -i '/^CFLAGS/s/-f(file|debug)-prefix-map=[^ ]* //g' Makefile.config
	touch $@

ocamlinit-stamp: $(TARBALL_TARGET) config-stamp
	$(MAKE) -f $(CURDIR)/debian/ocamlinit.mk ocamlinit-stamp

.PHONY: override_dh_auto_build
override_dh_auto_build: build-stamp

build-stamp: config-stamp
	if test ! -d boot.debian; then \
	  cp -xa boot boot.debian; \
	fi
ifeq ($(BUILDCACHE),)
	$(MAKE) world
	$(MAKE) -C tools dumpobj
ifneq (,$(OCAML_OPT_ARCH))
	@echo "Building native compilers"
	$(MAKE) opt opt.opt
	touch opt-built-stamp
endif
	@echo "Building manpages"
	$(MAKE) manpages
else
	@echo "===> WARNING: $(BUILDCACHE) detected, compilation skipped! <==="
	rsync -a --exclude=debian --exclude=.git $(BUILDCACHE)/ .
	rm -f build-stamp install-stamp*
endif
	touch $@

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
ifneq ($(wildcard $(CURDIR)/Makefile.config),)
	$(MAKE) clean
endif
	$(MAKE) -f $(CURDIR)/debian/ocamlinit.mk ocamlinit-clean
# Restore files altered by the build process
	if test -d boot.debian; then \
	  rm -Rf boot; \
	  mv boot.debian boot; \
	fi
	set -e; for ext in sub guess; do \
	  if [ -f debian/config.orig.$$ext ] ; then \
	    mv -f debian/config.orig.$$ext build-aux/config.$$ext; \
	  fi; \
	done
# Remaining stuff
	-rm -Rf debian/$(SRCTARBALL) $(TESTDIR)

execute_after_dh_clean:
	rm -f install-stamp-*
	rm -f debian/installed-files debian/*.install

.PHONY: override_dh_auto_install-arch override_dh_auto_install-indep
override_dh_auto_install-arch: install-stamp-arch
override_dh_auto_install-indep: install-stamp-indep

install-stamp-indep: install-stamp
	touch $@

install-stamp-arch: install-stamp
# Install additional files not handled by dh_install
# Beware: dh_install does not handle renamings, please pay attention
	set -e; for u in dumpobj; do \
	  if [ -f tools/$$u ]; then \
	    cp tools/$$u debian/ocaml/usr/bin/ocaml$$u; \
	  fi \
	done
# Install the seq compatibility package (OCaml >= 4.07)
	mkdir -p debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/seq
	cp debian/META.seq debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/seq/META
# Install the uchar compatibility package (OCaml >= 4.03)
	mkdir -p debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/uchar
	cp debian/META.uchar debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/uchar/META
# Install the stdlib-shims compatibility package (OCaml >= 4.07)
	mkdir -p debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/stdlib-shims
	cp debian/META.stdlib-shims debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/stdlib-shims/META
# Install the bigarray compatibility package (OCaml >= 5.2)
	mkdir -p debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/bigarray
	cp debian/META.bigarray debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/bigarray/META
# Install the bytes compatibility package (OCaml >= 5.2)
	mkdir -p debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/bytes
	cp debian/META.bytes debian/libstdlib-ocaml-dev$(OCAML_STDLIB_DIR)/bytes/META
# Remaining stuff
	touch $@

install-stamp:
# Install OCaml
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
ifeq (,$(DEB_TEST_BUILD_PREFIX))
# Remove Debian-specific file
	rm -f debian/tmp$(OCAML_STDLIB_DIR)/ld.conf
# Remove uninstalled files
	rm -f \
	  $(INSTDIR)/share/man/man1/ocamlopt.opt.1 \
	  $(INSTDIR)/share/man/man1/ocamlc.opt.1
ifeq ($(OCAML_HAVE_OCAMLOPT),no)
# Remove files that make no sense without ocamlopt
	rm -f \
	  $(INSTDIR)/share/man/man1/ocamloptp.1 \
	  $(INSTDIR)/share/man/man1/ocamlopt.1 \
	  $(INSTDIR)/bin/ocamloptp.* \
	  $(INSTDIR)/bin/ocamloptp
endif
# Remove irrelevant files
	rm -f \
	  $(INSTDIR)/share/doc/ocaml/README.win32.adoc \
	  $(INSTDIR)/share/doc/ocaml/LICENSE
# Dispatch files with dh_install
	find debian/tmp \( -type f -or -type l \) -printf '%P\n' > debian/installed-files
	boot/ocamlrun ./ocaml -nostdlib -I debian/tmp$(OCAML_STDLIB_DIR) debian/dispatch.ml
	dh_install

=== debian/watch ===
Version: 5

Source: https://caml.inria.fr/pub/distrib/ocaml-@ANY_VERSION@/
Matching-Pattern: ocaml-@ANY_VERSION@\.tar\.xz
Uversionmangle: s/\+/~/
